#include <avr/io.h>
#include "param.h"

.global SIG_OUTPUT_COMPARE0
SIG_OUTPUT_COMPARE0:
	push r16
	in r16, _SFR_IO_ADDR(SREG)
	push r16
	sbi _SFR_IO_ADDR(PORTD), LP
	push YL
	push YH
	push r17
	push r18
	cbi _SFR_IO_ADDR(PORTD), LP

//	lds YL, XStart					// Adresszhler auf nchste Zeile setzen
	clr YL
	lds YH, YCnt					// Zeilenadresse laden
	ldi r18, ((XSIZE/4)+XOScan)
	add r18, YL
	inc YH
	cbi _SFR_IO_ADDR(PORTD), FLM

Xshift:
	ld r16, Y+
	ld r16, Y+
	ld r16, Y+
	ld r16, Y+
	cp YL, r18
	brlo Xshift

	cpi YH, YMin
	brne not_firstline
	in r16, _SFR_IO_ADDR(PORTD)
	ldi r17, (1<<MOD)|(1<<FLM)
	eor r16, r17
	out _SFR_IO_ADDR(PORTD), r16
	wdr
not_firstline:
	cpi YH, YScan					// VSync ?
	brlo SkipAdRes
	ldi YH, YMin-1					// Adresszhler Reset
SkipAdRes:
	sts YCnt, YH

	pop r18
	pop r17
	pop YH
	pop YL
	pop r16
	out _SFR_IO_ADDR(SREG), r16
	pop r16
reti


.global lcd_setpixel
lcd_setpixel:
	ldi r18, hi8(XSIZE)
	cpi r24, lo8(XSIZE)
	cpc r25, r18
	brsh exitbit
	ldi r18, hi8(YSIZE)
	cpi r22, lo8(YSIZE)
	cpc r23, r18
	brsh exitbit

	mov r21, r24
	andi r21, 3
	ldi r20, 8
shift:								// r20 = 1<<r21
	cpi r21, 0
	breq exitshift
	lsr r20
	dec r21
	rjmp shift
exitshift:
	ldi r18, hi8(YSIZE/2)
	cpi r22, lo8(YSIZE/2)
	cpc r23, r18
	brlo obere				// Pixel in der oberen oder unteren Displayhlfte ?
	subi r22, lo8(YSIZE/2)
;	sbci r23, hi8(YSIZE/2)	// wird auf jedenfall zu 0, daher egal
	swap r20				// untere Hlfte -> Nibble vertauschen
obere:
	lsr r25
	ror r24
	lsr r25
	ror r24
	mov XL, r24
	mov XH, r22
	cli
	subi XH, (-(YMin))
	sbi _SFR_IO_ADDR(PORTD), XSCL
	ld r21, X				// Lade Wert aus SRAM
	or r21, r20				// Pixel setzen
	st X, r21				// Wert in SRAM schreiben
normalp:
	cbi _SFR_IO_ADDR(PORTD), XSCL		
	sei
exitbit:
ret

.global lcd_writebyte		// X: r24
lcd_writebyte:				// Y: r22:23
							// DATA: r20
	cpi r24, (XSIZE/4)
	brsh exitbyte
	ldi r18, hi8(YSIZE)
	cpi r22, lo8(YSIZE)
	cpc r23, r18
	brsh exitbyte
	mov XL, r24
	ldi r18, hi8(YSIZE/2)
	cpi r22, lo8(YSIZE/2)
	cpc r23, r18
	brsh untereHaelfte		// Byte in der oberen oder unteren Displayhlfte ?
	mov XH, r22	
	swap r20
	cli
	subi XH, (-(YMin))
	sbi _SFR_IO_ADDR(PORTD), XSCL
	ld r18, X
	andi r18, 240			;untere Datenhlfte der SRAM Daten behalten
	mov r19, r20
	andi r19, 15			;erste Hlfte der Daten behalten
	or r18, r19
	st X+,r18
	ld r18, X
	andi r18, 240			;untere Datenhlfte der SRAM Daten behalten
	swap r20
	andi r20, 15			;zweite Hlfte der Daten behalten
	or r18, r20
	st X+,r18
	cbi _SFR_IO_ADDR(PORTD), XSCL
	sei
	ret

untereHaelfte:
	mov XH, r22
	subi XH, lo8(YSIZE/2)
	cli
	subi XH, (-(YMin))
	sbi _SFR_IO_ADDR(PORTD), XSCL
	ld r18, X				;Lader Wert aus SRAM
	andi r18, 15			;obere Datenhlfte der SRAM Daten behalten
	mov r19, r20
	andi r19, 240			;erste Hlfte der Daten behalten
	or r18, r19			;Beide Hlften zusammenfgen
	st X+,r18
	ld r18, X
	andi r18, 15			;obere Datenhlfte der SRAM Daten behalten
	swap r20
	andi r20, 240			;zweite Hlfte der Daten behalten
	or r18, r20
	st X+,r18
	cbi _SFR_IO_ADDR(PORTD), XSCL
	sei
exitbyte:
ret

.global lcd_writechar		// X: r24:25
lcd_writechar:				// Y: r22:23
							// C: r20
	mov ZL, r20
	ldi ZH, TEXT_Y
	mul ZL, ZH
	movw ZL, r0
	subi ZL, lo8(-(font))
	sbci ZH, hi8(-(font))

	ldi r21, TEXT_Y
wchar:
	lpm r20, Z+
	rcall lcd_writebyte
	subi r22, lo8(-1)			// Zeilen Adresse ++
	sbci r23, hi8(-1)
	dec r21
	brne wchar
	clr r1
ret
